/*###############################################################################
## ETiles project
##
## Copyright (C) 2010 Carlos Villegas Núñez  carlos.villegasnunez@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include "listatiles.h"

ListaTiles::ListaTiles()
{
    setDragEnabled(true);
    setViewMode(QListView::IconMode); //Modo de vista de los tiles en iconos
    setIconSize(QSize(32,32));
    setGridSize(QSize(33,33));
    setSpacing(1); //Espaciado entre cada icono
    setMovement(QListView::Snap);
    setAcceptDrops(true);
    setDropIndicatorShown(true);
    setResizeMode(QListView::Adjust); //Cada vez que se redimensione la lista, reajustamos los tiles dentro de ella

    //Barra de herramientas interna
    barra = new QToolBar();

    eliminar = new QAction(QIcon("../imagenes/iconos/32x32/eliminar32.png"),tr("Eliminar"),this);
    barra->addAction(eliminar);
    anadir = new QAction(QIcon("../imagenes/iconos/32x32/anadir32.png"),tr("Añadir"),this);
    barra->addAction(anadir);
    anadirtileset = new QAction(QIcon("../imagenes/iconos/32x32/cargartileset32.png"),tr("Añadir Tileset"),this);
    barra->addAction(anadirtileset);
}

int ListaTiles::TileSeleccionado() const{
    if(currentIndex().isValid())
    {
        int i= currentIndex().row();
        return i;
    }
    else
        return -1;

}
