/*###############################################################################
## ETiles project
##
## Copyright (C) 2010 Carlos Villegas Núñez  carlos.villegasnunez@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include "propmapa.h"
#include "ui_propmapa.h"

#include "QPainter"

propmapa::propmapa(QWidget *parent, QColor crejilla, QColor cmapa, QColor csel) :
    QDialog(parent), cr(crejilla), cf(cmapa), cs(csel),
    ui(new Ui::propmapa)
{
    ui->setupUi(this);

    ui->elegirf->setAutoFillBackground(true);
    ui->elegirr->setAutoFillBackground(true);
    ui->elegirs->setAutoFillBackground(true);

    QPalette p=ui->elegirf->palette();
    p.setColor(ui->elegirf->backgroundRole(),cf);
    ui->elegirf->setPalette(p);
    p.setColor(QPalette::Base,cr);
    ui->elegirr->setPalette(p);
    p.setColor(QPalette::Base,cs);
    ui->elegirs->setPalette(p);
}

propmapa::~propmapa()
{
    delete ui;
}

void propmapa::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void propmapa::on_elegirr_clicked()
{
    cr = diar.getColor(Qt::black, this);
    if (cr.isValid()) {
        QPalette p=ui->elegirr->palette();
        p.setColor(ui->elegirr->backgroundRole(),cr);
        ui->elegirr->setPalette(p);
    }

}

void propmapa::on_elegirs_clicked()
{
    cs = dias.getColor(Qt::black, this);
    if (cs.isValid()) {
        QPalette p=ui->elegirs->palette();
        p.setColor(ui->elegirs->backgroundRole(),cs);
        ui->elegirs->setPalette(p);
    }
}

void propmapa::on_elegirf_clicked()
{
    cf = diaf.getColor(Qt::black, this);
    if (cf.isValid()) {
        QPalette p=ui->elegirf->palette();
        p.setColor(ui->elegirf->backgroundRole(),cf);
        ui->elegirf->setPalette(p);
    }
}

void propmapa::on_buttonBox_accepted()
{
   ((VentanaPrincipal*)(this->parentWidget()))->getMapa()->setColorFondo(cf);
   ((VentanaPrincipal*)(this->parentWidget()))->getMapa()->setColorRejilla(cr);
   ((VentanaPrincipal*)(this->parentWidget()))->getMapa()->setColorSel(cs);
   ((VentanaPrincipal*)(this->parentWidget()))->getMapa()->update();
   accept();
}

void propmapa::on_buttonBox_rejected()
{
    reject();
}
