#include <iostream>
#include <list>
#include <string>
#include <iomanip>

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

using namespace std;

#ifndef PERLIN_H_

#define PERLIN_H_

#define SAMPLE_SIZE 1024

class Perlin
{
public:

  Perlin(int octaves,float freq,float amp,int seed);


  float Get(float x,float y)
  {
    float vec[2];
    vec[0] = x;
    vec[1] = y;
    return perlin_noise_2D(vec);
  };

private:
  void init_perlin(int n,float p);
  float perlin_noise_2D(float vec[2]);

  float noise1(float arg);
  float noise2(float vec[2]);
  float noise3(float vec[3]);
  void normalize2(float v[2]);
  void normalize3(float v[3]);
  void init(void);

  int   mOctaves;
  float mFrequency;
  float mAmplitude;
  int   mSeed;

  int p[SAMPLE_SIZE + SAMPLE_SIZE + 2];
  float g3[SAMPLE_SIZE + SAMPLE_SIZE + 2][3];
  float g2[SAMPLE_SIZE + SAMPLE_SIZE + 2][2];
  float g1[SAMPLE_SIZE + SAMPLE_SIZE + 2];
  bool  mStart;

};

#endif


class SDLETiles{

public:
	SDLETiles();
	//SDLETiles(int anchura,int altura, int numanchura, int numaltura);
	int AnchuraTile() const { return tanchura;}
     	int AlturaTile() const { return taltura;}
     	int NumAnchuraTile() const { return tnumanc;}
     	int NumAlturaTile() const { return tnumalt;}
     	int TilePosicion(int x, int y) const { return matrizTiles[x][y];}
     	void setTilePosicion(int valor,int x, int y) { matrizTiles[x][y] = valor;}

	void crearMapaAleatorio(int tanchura,int taltura, int tnumanchura, int tnumaltura,list<SDL_Surface*> ltiles, int aguatierra, int contislas, int monvar, int semilla,int eleccion);
	void cargarMapa(const char * ruta, const char *rutatiles);
	void pintarEnSuperficie(SDL_Surface *superficie) ;
	
private:
	void aleatorioPerlin(int octaves, double frecuencia, double amplitud, int semilla,double margen);

	int tanchura,taltura,tnumanc,tnumalt;
	list<SDL_Surface*> listatiles;
	list<string> listarutastiles;
	int **matrizTiles;
};


