#include <iostream>
#include <iomanip>
#include "etilessdl.h"

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#define TEMPO 80

using namespace std;

int main()
{

    // Iniciamos el subsistema de video

    if(SDL_Init(SDL_INIT_VIDEO) < 0) {

	cerr << "No se pudo iniciar SDL: " << SDL_GetError() << endl;
	exit(1);
	
    }


    atexit(SDL_Quit);

    // Comprobamos que sea compatible el modo de video
    
    if(SDL_VideoModeOK(800, 600, 24, SDL_HWSURFACE|SDL_DOUBLEBUF) == 0) {
	
        cerr << "Modo no soportado: " << SDL_GetError() << endl;
        exit(1);
	
    }


    // Establecemos el modo de video

    SDL_Surface *pantalla;

    pantalla = SDL_SetVideoMode(800, 600, 24, SDL_HWSURFACE|SDL_DOUBLEBUF);

    if(pantalla == NULL) {

        cerr << "No se pudo establecer el modo de video: "
             << SDL_GetError() << endl;

        exit(1);
    }

    SDL_Event evento;
    int i = 0;
    Uint32 negro = SDL_MapRGB(pantalla->format, 0, 0, 0);

    Uint32 t0 = SDL_GetTicks();
    Uint32 t1;

    SDLETiles mapa;
    SDL_Surface *superficie_mapa;

	SDL_Rect rect; rect.x=64; rect.y=64; rect.w=32; rect.h=32;

	list<SDL_Surface*> listatiles;
	SDL_Surface *sup = IMG_Load("../../imagenes/tiles/agua_clara.png");
	listatiles.push_back(sup);
	sup = IMG_Load("../../imagenes/tiles/agua_media.png");
	listatiles.push_back(sup);
	sup = IMG_Load("../../imagenes/tiles/agua_oscura.png");
	listatiles.push_back(sup);
	sup = IMG_Load("../../imagenes/tiles/agua_oscura1.png");
	listatiles.push_back(sup);
	sup = IMG_Load("../../imagenes/tiles/hierba_clara.png");
	listatiles.push_back(sup);
	sup = IMG_Load("../../imagenes/tiles/hierba_densa.png");
	listatiles.push_back(sup);
	sup = IMG_Load("../../imagenes/tiles/hierba_oscura.png");
	listatiles.push_back(sup);
	sup = IMG_Load("../../imagenes/tiles/hierba.png");
	listatiles.push_back(sup);
	mapa.crearMapaAleatorio(20,20,40,30,listatiles,62,44,86,5,0);

	mapa.pintarEnSuperficie(pantalla);
	SDL_BlitSurface(superficie_mapa,NULL,pantalla,NULL);		
	SDL_Flip(pantalla);


for( ; ; ) {
	
	while(SDL_PollEvent(&evento)) {
	    
	    if(evento.type == SDL_KEYDOWN) {
	
		if(evento.key.keysym.sym == SDLK_ESCAPE)
		    
		    return 0;

		if(evento.key.keysym.sym == SDLK_f)
		    SDL_WM_ToggleFullScreen(pantalla);

	    }

	    if(evento.type == SDL_QUIT)
		
		return 0;
	    
	    
	}
    }

}
